/*
** Copyright (C) 2006 Jesse Chappell <jesse@essej.net>
**  
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
**  
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**  
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software
** Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
**  
*/

#ifndef __ac3jack_encoder__
#define __ac3jack_encoder__

#include <stdint.h>

#include "types.hpp"

#include <aften/aften.h>
#include <aften/aften-types.h>

namespace AC3JACK
{


struct EncoderParams
{
	int64_t duration;
	unsigned int channels;
	int bitdepth;
	int bitrate;
	unsigned int sample_rate;
	bool lfe;
};

	
class Encoder
{
  public:

	Encoder();
	virtual ~Encoder();

	bool set_params(const EncoderParams & params);

	bool initialize();

	int run (unsigned char * ac3buf, const sample_t * samplebuf, nframes_t count);
	
	
  protected:

	AftenContext _aften_context;
	bool _initialized;
};

}

#endif
