/*
** Copyright (C) 2004 Jesse Chappell <jesse@essej.net>
**  
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
**  
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**  
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software
** Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
**  
*/

#ifndef __ac3jack_connections_popup__
#define __ac3jack_connections_popup__


#include <wx/wx.h>

#include <string>
#include <vector>
#include <iostream>

#include <sigc++/object.h>
#include <sigc++/signal.h>
#include <sigc++/connection.h>


namespace AC3JACKGui {

class OscClient;
	
class ConnectionsPopup
	: public wxMenu,  public SigC::Object
{
public:
	
	ConnectionsPopup (wxWindow *parent, OscClient * osc, const wxString &chan);
	virtual ~ConnectionsPopup();
	
	void OnSelectItem(wxCommandEvent &event);

protected:

	OscClient * _osc;
	wxString  _chan;
	
private:
	DECLARE_EVENT_TABLE()
};

}
#endif
