/*
** Copyright (C) 2007 Jesse Chappell <jesse@essej.net>
**  
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
**  
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**  
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software
** Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
**  
*/

#ifndef __ac3jack_spdifwriter__
#define __ac3jack_spdifwriter__

#include <string>
#include "types.hpp"
#include "thread_writer.hpp"

namespace AC3JACK
{

class SpdifWriter
	: public ThreadWriter
{
  public:
	SpdifWriter() {}
	virtual ~SpdifWriter() {}

	virtual std::string get_status() { return _status; }

	virtual int get_devices(DeviceInfoList & retlist) {return 0;}

	virtual void set_device (std::string devstr) {}
	virtual std::string get_device () { return "";}

	virtual void set_allow_pcm (bool val) {}
	virtual bool get_allow_pcm () const { return false; }

  protected:

	std::string                    _status;
	
};



	

}


#endif
