/*
** Copyright (C) 2006 Jesse Chappell <jesse@essej.net>
**  
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
**  
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**  
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software
** Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
**  
*/

#include <iostream>

#include "thread_writer.hpp"


using namespace AC3JACK;
using namespace std;


ThreadWriter::ThreadWriter()
{
	_active = false;
	_butler_thread = 0;
}

void ThreadWriter::start()
{
	Butler worker(this);

	_active = true;

	_butler_thread = new boost::thread(worker);	
}


ThreadWriter::~ThreadWriter()
{
	if (_active) {
		_active = false;
		
		{
			boost::try_mutex::scoped_try_lock lk(_butler_mutex);
			_more_incoming.notify_one();
		}
		
		cerr << "waiting for butler thread to end" << endl;
		_butler_thread->join();
	}
	
	if (_butler_thread) {
		delete _butler_thread;
		_butler_thread = 0;
	}
}


